<?php
$rs='';

class PHPDB {
    public static $basedir = './';
    public static $mft = 'mft.pdb';
    public static $data_defs = 'data_defs.pdb';
    ////////////////////////////////////////////////////
    //Functions for manupulating the Master File Table//
    ////////////////////////////////////////////////////
    
    function add_file($file_name, $content_title, $params=''){
        $name = explode('/',$file_name);
        $params['source'] = $file_name;
        $params['title'] = $content_title;
        $params['type'] = $name[0];
        echo "$file_name";
        $mime = mime_content_type(PHPDB::$basedir."$file_name");
        if (preg_match("/x-empty/", $mime) || preg_match("/text/", $mime)){
            $data_def = PHPDB::get_data_def('text');
        }
        else if (preg_match("/image/", $mime)){
            $data_def = PHPDB::get_data_def('image');
        }else{
            $rs = 'This file has a mime type that is unrecognized by PHPDB. So far the file types supported are \"text\" and \"image\" and their sub-variants.';
        }
        
        if(isset($data_def)){
            
            $mft_file = fopen(PHPDB::$basedir.PHPDB::$mft,'a');
            $record = '';
                foreach($data_def as $field){
                    if ($field !=$name[0]){
                        $record[$field] = @$params[$field]."::";
                    }else{
                        $record[$field] = $name[1]."::";
                    }
                }

                fwrite($mft_file,substr(implode($record),0,-2)."\n");
            fclose($mft_file); 
            $rs = $params['title'].' has been added as '.$mime;
        }
        unset($data_def);
 
        return $rs;
    }
    
    function remove_file($file_name){
         if(unlink(PHPDB::$basedir."$file_name")){
             return PHPDB::$basedir."$file_name has been deleted.";
         }else{
             die("There is an issue with the permissions on ".PHPDB::$basedir."$file_name or it does not exist.");
         }
         PHPDB::DBcleanup(PHPDB::$basedir.PHPDB::$mft);
         chmod(PHPDB::$basedir.PHPDB::$mft, 0777);
    }
    
    function DBcleanup(){
        chmod(PHPDB::$basedir.PHPDB::$mft, 0777);
        $data = @fopen(PHPDB::$basedir.PHPDB::$mft, "r");
        $temp_data = @fopen(PHPDB::$basedir."temp_data.pdb", "w");
        fclose($temp_data);
        chmod(PHPDB::$basedir."temp_data.pdb", 0777);
        $temp_data = @fopen(PHPDB::$basedir."temp_data.pdb", "a");
        
        if ($data) {
            while (($line = fgets($data)) !== false) {
                $name = explode("::", $line);
                $file = $name[1];
                if (file_exists("$file")){
                    fwrite($temp_data, $line);
                }   
            }
            fclose($data);
            fclose($temp_data);
            unlink(PHPDB::$basedir.PHPDB::$mft);
            rename(PHPDB::$basedir."temp_data.pdb", PHPDB::$basedir.PHPDB::$mft); 
            chmod(PHPDB::$basedir.PHPDB::$mft, 0777);
        }          
    }
    
    ///////////////////
    //Query Functions//
    ///////////////////
    
    function select_one($params, $type){
        global $rs;
        $rs = '';//Does some wierd things when not unset and run multiple times
        $data = fopen(PHPDB::$basedir.PHPDB::$mft, "r");
        $num = 0;
        while (($line = fgets($data)) !== false) {
            $attrib = explode("::",$line);
            if (preg_match("/$params/i", $line) && @$attrib[2]==$type){
                PHPDB::select_types($attrib, $type, $num);
            }
        }
        return $rs[0];
        fclose($data);        
    }
    
    function select_multi($params, $type){
        global $rs;
        $rs = '';//Does some wierd things when not unset and run multiple times
        $data = fopen(PHPDB::$basedir.PHPDB::$mft, "r");
        $num = 0;
        while (($line = fgets($data)) !== false) {
            $attrib = explode("::",$line);
            if (preg_match("/$params/i", $line) && $attrib[2]==$type){
                PHPDB::select_types($attrib, $type, $num);
            }
            $num++;
        }
        return $rs;
        fclose($data);
    }
    
   ////////////////////
   //Common Functions//
   ////////////////////
    
    function select_types($attrib, $type, $num = 0){  
        global $rs;
        $data_def = PHPDB::get_data_def($type);
        if ($type=='text'){
            $the_data = fopen(PHPDB::$basedir."$attrib[1]", "r");
            while (($line = fgets($the_data)) !== false) {
                $stuff = explode("::", $line);
                $rs[$num]["$stuff[0]"] = $stuff[1];   
            }
            fclose($the_data);
        }else if($type=='image'){
            for($i=0;$i<sizeof($data_def);$i++){
                $rs[$num][$data_def[$i]] = $attrib[$i];
            }
        }
        //print_r($rs);
    }
    
    function get_data_def($type){
        $data = fopen(PHPDB::$basedir.PHPDB::$data_defs, "r");
        while (($line = fgets($data)) !== false) {
            if (preg_match("/$type/i", $line)){
                $line = explode('::',$line);
                $def = $line;
                unset($def[sizeof($def)-1]);
                break;
            }
        }
        fclose($data);
        return $def;
    }
}
?>
